"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simulator = exports.assemble = void 0;
var assembler_1 = require("@src/simulator/assembler");
var constants_1 = require("@src/utils/constants");
var functions_1 = require("@src/utils/functions");
function assemble(assemblyInstructions, mappingDetailRequest) {
    /*
     * input : assemblyInstructions: string[]
     * Enter the path where the assembly file is located.
     
     * If the assemlbyFile path is /Users/junghaejune/simulator/sample_input/example1.s
     * you can enter path /Users/junghaejune/simulator/sample_input/example1.s into assemblyInstructions.
     * If you don't know the path exactly, you can use makeInput function in functions.ts
     * Let your current directory is simulator (/Users/junghaejune/simulator).
     * Then you only put makeInput("sample_input", "example1.s") into assemblyInstructions
  
     * output: string[]
     * The assembly file is converted to a string in binary form.
      
      ex)
      input: sample_input/example1.s
      ...
      main:
        and	$17, $17, $0
        and	$18, $18, $0
      ...
      
      output:
      [00000010001000001000100000100100,
        ...
      00000010010000001001000000100100]
  
    */
    if (mappingDetailRequest === void 0) { mappingDetailRequest = false; }
    var _a = (0, assembler_1.makeBinaryObject)(assemblyInstructions), dataSectionSize = _a.dataSectionSize, textSectionSize = _a.textSectionSize, binaryText = _a.binaryText, binaryData = _a.binaryData, mappingTable = _a.mappingTable, dataSeg = _a.dataSeg, textSeg = _a.textSeg;
    var mappingDetail = null;
    var output = (0, assembler_1.makeBinaryArray)(dataSectionSize, textSectionSize, binaryText, binaryData);
    if (mappingDetailRequest) {
        mappingDetail = (0, functions_1.makeMappingDetail)(assemblyInstructions, dataSeg, textSeg, mappingTable, output);
    }
    return { output: output, mappingDetail: mappingDetail };
}
exports.assemble = assemble;
function simulator(assemblyInstructions, cycleNum, returnHistory) {
    if (returnHistory === void 0) { returnHistory = false; }
    return __awaiter(this, void 0, void 0, function () {
        var _a, dataSectionSize, textSectionSize, binaryText, binaryData, CYCLES, INST_INFO, result;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = (0, assembler_1.makeBinaryObject)(assemblyInstructions), dataSectionSize = _a.dataSectionSize, textSectionSize = _a.textSectionSize, binaryText = _a.binaryText, binaryData = _a.binaryData;
                    (0, constants_1.initializeMem)();
                    CYCLES = new Array();
                    INST_INFO = (0, constants_1.initialize)(binaryText.concat(binaryData), textSectionSize, dataSectionSize);
                    return [4 /*yield*/, (0, functions_1.mainProcess)(INST_INFO, cycleNum, CYCLES)];
                case 1:
                    result = _b.sent();
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            try {
                                var output = { result: result, history: null };
                                if (returnHistory)
                                    output.history = CYCLES;
                                resolve(output);
                            }
                            catch (error) {
                                reject(error);
                            }
                        })];
            }
        });
    });
}
exports.simulator = simulator;
