"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.running = exports.rdump = exports.mdump = exports.dumpMemory = exports.cycle = exports.mainProcess = exports.getInstInfo = exports.initInstInfo = exports.initMemory = exports.memWriteHalf = exports.memWrite = exports.memRead = exports.fromBinary = exports.makeMappingDetail = exports.makeObjectFile = exports.makeOutput = exports.parseSimulatorOutput = exports.simulatorUnitTest = exports.makeInput = exports.isEmpty = exports.log = exports.symbolTableAddEntry = exports.toHexAndPad = exports.numToBits = exports.printParseResult = exports.parseData = exports.parseInstr = void 0;
var path = __importStar(require("path"));
var fs = __importStar(require("fs"));
var process_1 = require("process");
var run_1 = require("@simulator/run");
var constants_1 = require("@utils/constants");
function parseInstr(buffer, index) {
    var instr = new constants_1.instruction();
    (0, run_1.setOPCODE)(instr, fromBinary(buffer.slice(0, 6)));
    // R type
    if (instr.opcode === 0x0) {
        (0, run_1.setRS)(instr, fromBinary(buffer.slice(6, 11)));
        (0, run_1.setRT)(instr, fromBinary(buffer.slice(11, 16)));
        (0, run_1.setRD)(instr, fromBinary(buffer.slice(16, 21)));
        (0, run_1.setSHAMT)(instr, fromBinary(buffer.slice(21, 26)));
        (0, run_1.setFUNC)(instr, fromBinary(buffer.slice(26, 32)));
    }
    // J type
    else if (instr.opcode === 0x2 || instr.opcode === 0x3) {
        (0, run_1.setTARGET)(instr, fromBinary(buffer.slice(6, 32)));
    }
    // I type
    else {
        (0, run_1.setRS)(instr, fromBinary(buffer.slice(6, 11)));
        (0, run_1.setRT)(instr, fromBinary(buffer.slice(11, 16)));
        (0, run_1.setIMM)(instr, fromBinary(buffer.slice(16, 32)));
    }
    memWrite(constants_1.MEM_TEXT_START + index, fromBinary(buffer));
    return instr;
}
exports.parseInstr = parseInstr;
function parseData(buffer, index) {
    //[TODO] Implement this function
    memWrite(constants_1.MEM_DATA_START + index, fromBinary(buffer));
    return;
}
exports.parseData = parseData;
function printParseResult(INST_INFO, textSize, dataSize) {
    console.log('Instruction Information');
    /*
      TYPE I
      0x8: (0x001000)ADDI
      0x9: (0x001001)ADDIU
      0xc: (0x001100)ANDI
      0x4: (0x000100)BEQ
      0x5: (0x000101)BNE
      0x25: (0x011001)LHU
      0xf: (0x001111)LUI
      0x23: (0x100011)LW
      0xd: (0x001101)ORI
      0xa: (0x001010)SLTI
      0xb: (0x001011)SLTIU
      0x29: (0x011101)SH
      0x2b: (0x101011)SW
  
      TYPE R
      0x0: (0x000000)ADD, ADDU, AND, NOR, OR, SLT, SLTU, SLL, SRL, SUB, SUBU  if JR
  
      TYPE J
      0x2: (0x000010)J
      0x3: (0x000011)JAL
      */
    var TypeIList = [
        0x8, 0x9, 0xc, 0x4, 0x5, 0x25, 0xf, 0x23, 0xd, 0xa, 0xb, 0x29, 0x2b,
    ];
    var TypeRList = [0x0];
    var TypeJList = [0x2, 0x3];
    for (var i = 0; i < textSize / 4; i++) {
        console.log("INST_INFO[".concat(i, "].value : 0x").concat(INST_INFO[i].value.toString(16)));
        console.log("INST_INFO[".concat(i, "].opcode : ").concat(INST_INFO[i].opcode));
        if (INST_INFO[i].opcode in TypeIList) {
            console.log("INST_INFO[".concat(i, "].rs : ").concat(INST_INFO[i].rs));
            console.log("INST_INFO[".concat(i, "].rt : ").concat(INST_INFO[i].rt));
            console.log("INST_INFO[".concat(i, "].imm : ").concat(INST_INFO[i].imm));
        }
        else if (INST_INFO[i].opcode in TypeRList) {
            console.log("INST_INFO[".concat(i, "].funcCode : ").concat(INST_INFO[i].funcCode));
            console.log("INST_INFO[".concat(i, "].rs : ").concat(INST_INFO[i].rs));
            console.log("INST_INFO[".concat(i, "].rt : ").concat(INST_INFO[i].rt));
            console.log("INST_INFO[".concat(i, "].rd : ").concat(INST_INFO[i].rd));
            console.log("INST_INFO[".concat(i, "].shamt : ").concat(INST_INFO[i].shamt));
        }
        else if (INST_INFO[i].opcode in TypeJList) {
            console.log("INST_INFO[".concat(i, "].target : ").concat(INST_INFO[i].target));
        }
        else {
            console.log('Not available instrution\n');
        }
    }
    console.log('Memory Dump - Text Segment\n');
    for (var i = 0; i < textSize; i += 4) {
        console.log("text_seg[".concat(i, "] : 0x").concat(memRead(constants_1.MEM_TEXT_START + i).toString(16)));
    }
    for (var i = 0; i < dataSize; i += 4) {
        console.log("text_seg[".concat(i, "] : 0x").concat(memRead(constants_1.MEM_DATA_START + i).toString(16)));
    }
    console.log("Current PC: ".concat(constants_1.currentState.PC.toString(16)));
}
exports.printParseResult = printParseResult;
function numToBits(num, pad) {
    if (pad === void 0) { pad = 32; }
    // 10진수 정수를 2진수 bit로 변경해서 return
    if (num >= 0) {
        return num.toString(2).padStart(pad, '0'); //양수일때
    }
    else {
        num = Math.pow(2, pad) + num;
        return num.toString(2).padStart(pad, '0'); //음수일때;
    }
}
exports.numToBits = numToBits;
function toHexAndPad(num, pad) {
    if (pad === void 0) { pad = 8; }
    /*
     * num : Number or String(숫자 형식, 10진법), pad : Number
     * input : 18 => output: '00000012'
     * Recommend | num을 Number 타입으로 넣을 것
     */
    return Number(num).toString(16).padStart(pad, '0');
}
exports.toHexAndPad = toHexAndPad;
function symbolTableAddEntry(symbol) {
    constants_1.SYMBOL_TABLE[symbol.name] = symbol.address;
    if (constants_1.DEBUG) {
        log(1, "".concat(symbol.name, ": 0x").concat(toHexAndPad(symbol.address)));
    }
}
exports.symbolTableAddEntry = symbolTableAddEntry;
function log(printType, content) {
    console.log(constants_1.pType[printType] + content);
}
exports.log = log;
function isEmpty(value) {
    var emptyArray = [''];
    if (value === '' ||
        value === null ||
        value === undefined ||
        (value !== null &&
            typeof value === 'object' &&
            !Object.keys(value).length) ||
        value === emptyArray) {
        return true;
    }
    else {
        return false;
    }
}
exports.isEmpty = isEmpty;
// Parsing an assembly file(*.s) into a list
function makeInput(inputFolderName, inputFileName) {
    /*
     if the inputFilePath is /Users/junghaejune/simulator/sample_input/sample/example1.s,
      currDirectory : /Users/junghaejune/simulator
      inputFolderPath : sample_input/sample
      inputFileName: example1.s
    */
    var currDirectory = process.cwd();
    var inputFilePath = path.join(currDirectory, inputFolderName, inputFileName);
    try {
        if (fs.existsSync(inputFilePath) === false)
            throw 'INPUT_PATH_ERROR';
        var input = fs.readFileSync(inputFilePath, 'utf-8');
        if (isEmpty(input))
            throw 'INPUT_EMPTY';
        return input.split('\n');
    }
    catch (err) {
        if (err === 'INPUT_PATH_ERROR') {
            log(3, "No input file ".concat(inputFileName, " exists. Please check the file name and path."));
        }
        else if (err === 'INPUT_EMPTY') {
            log(3, "input file ".concat(inputFileName, " is not opened. Please check the file"));
        }
        else
            console.error(err);
        (0, process_1.exit)(1);
    }
}
exports.makeInput = makeInput;
function simulatorUnitTest(testCase, output) {
    function printResult(origin, compare) {
        Object.keys(origin).map(function (key) {
            if (compare[key]) {
                var color = origin[key] === compare[key] ? constants_1.bcolors.GREEN : constants_1.bcolors.RED;
                console.log("".concat(color).concat(key, " : ").concat(origin[key], "          ").concat(key, " : ").concat(compare[key]).concat(constants_1.bcolors.ENDC));
            }
            else {
                console.log("".concat(constants_1.bcolors.RED).concat(key, " : ").concat(origin[key]).concat(constants_1.bcolors.ENDC));
            }
        });
    }
    var keyList = ['registers', 'dataSection', 'stackSection'];
    console.log("---------------PC---------------");
    console.log("".concat(testCase.PC === output.PC ? constants_1.bcolors.GREEN : constants_1.bcolors.RED, "PC : ").concat(testCase.PC, "          PC : ").concat(output.PC).concat(constants_1.bcolors.ENDC, "\n"));
    keyList.map(function (key) {
        console.log("---------------".concat(key, "---------------"));
        printResult(testCase[key], output[key]);
        console.log('\n');
    });
}
exports.simulatorUnitTest = simulatorUnitTest;
function parseSimulatorOutput(rawOutput) {
    //input : test simulator input
    //ouput : object type -> { register : {PC:, R0:,...}, dataSection:{}, stackSection{}}
    function splitHelper(input) {
        var returnValue = input.split(/:|\n/);
        return returnValue.length === 2
            ? [returnValue[0], returnValue[1].trim()]
            : null;
    }
    function setTypeParser(input) {
        var returnSet = {};
        input
            .split(/\n/)
            .filter(function (e) { return e !== ''; })
            .map(function (element) {
            var result = splitHelper(element);
            result ? (returnSet[result[0]] = result[1]) : null;
        });
        return returnSet;
    }
    var outputList = rawOutput
        .split(/Program Counter\n|Registers\n|Data section|Stack section\n/)
        .filter(function (e) { return e !== ''; });
    var PC = setTypeParser(outputList[0]);
    var registers = setTypeParser(outputList[1]);
    var dataSection = setTypeParser(outputList[2] || '');
    var stackSection = setTypeParser(outputList[3] || '');
    return { PC: PC.PC, registers: registers, dataSection: dataSection, stackSection: stackSection };
}
exports.parseSimulatorOutput = parseSimulatorOutput;
function makeOutput(inputFolderName, inputFileName) {
    /*
     if the inputFilePath is /Users/junghaejune/simulator/sample_input/sample/example1.s,
      currDirectory : /Users/junghaejune/simulator
      inputFolderPath : sample_input/sample
      inputFileName: example1.s
    */
    var currDirectory = process.cwd();
    var inputFilePath = path.join(currDirectory, inputFolderName, inputFileName);
    try {
        if (fs.existsSync(inputFilePath) === false)
            throw 'INPUT_PATH_ERROR';
        var input = fs.readFileSync(inputFilePath, 'utf-8');
        if (isEmpty(input))
            throw 'INPUT_EMPTY';
        return input;
    }
    catch (err) {
        if (err === 'INPUT_PATH_ERROR') {
            log(3, "No input file ".concat(inputFileName, " exists. Please check the file name and path."));
        }
        else if (err === 'INPUT_EMPTY') {
            log(3, "input file ".concat(inputFileName, " is not opened. Please check the file"));
        }
        else
            console.error(err);
        (0, process_1.exit)(1);
    }
}
exports.makeOutput = makeOutput;
// Create an Object file(*.o) in the desired path
function makeObjectFile(outputFolderPath, outputFileName, content) {
    /*
     if the outputFilePath is /Users/junghaejune/simulator/sample_input/sample/example1.s,
      currDirectory : /Users/junghaejune/simulator
      outputFolderPath : sample_input/sample
      outputFileName: example1.o
      content : ['01010', '01010']
    */
    var currDirectory = process.cwd();
    var outputFilePath = path.join(currDirectory, outputFolderPath, outputFileName);
    try {
        if (fs.existsSync(outputFilePath) === true) {
            fs.unlink(outputFilePath, function (err) {
                err
                    ? console.error(err)
                    : log(0, "Output file ".concat(outputFileName, " exists. Remake the file"));
            });
        }
        else
            throw 'OUTPUT_NOT_EXISTS';
        var fd_1 = fs.openSync(outputFilePath, 'a');
        content.forEach(function (item) {
            fs.appendFileSync(fd_1, item + '\n', 'utf-8');
        });
        fs.closeSync(fd_1);
    }
    catch (err) {
        if (err === 'OUTPUT_NOT_EXISTS') {
            log(0, "Output file ".concat(outputFileName, " does not exists. Make the file"));
        }
        else
            console.error(err);
        (0, process_1.exit)(1);
    }
}
exports.makeObjectFile = makeObjectFile;
function makeMappingDetail(assemblyFile, dataSeg, textSeg, mappingTable, output) {
    var mappingDetail = [];
    var textCounter = 0;
    assemblyFile.forEach(function (assemblyLine, i) {
        var binaryInstructionNumbers = [];
        var binaryInstructions = [];
        if (assemblyLine.includes('.data')) {
            binaryInstructionNumbers.push(0);
            binaryInstructions = [output[0]];
        }
        else if (assemblyLine.includes('.word')) {
            var dataSegIndex = dataSeg.indexOf(assemblyLine.split('\t')[2]);
            var dataIndex = output.length - dataSeg.length + dataSegIndex;
            binaryInstructionNumbers.push(dataIndex);
            binaryInstructions = [output[dataIndex]];
        }
        else if (assemblyLine.includes('.text')) {
            binaryInstructionNumbers.push(1);
            binaryInstructions = [output[1]];
        }
        else {
            var binaryIndexes = mappingTable[textCounter];
            binaryInstructions = binaryIndexes.map(function (index) {
                binaryInstructionNumbers.push(index + 2);
                return output[index + 2];
            });
            assemblyLine === textSeg[textCounter] && textCounter++;
        }
        var binaryData = [];
        binaryInstructions.forEach(function (inst, j) {
            var binaryInstructionIndex = binaryInstructionNumbers[j];
            var temp = {
                lineNumber: binaryInstructionIndex,
                data: inst,
            };
            binaryData.push(temp);
        });
        mappingDetail.push({
            key: i,
            assembly: assemblyLine,
            binary: binaryData,
        });
    });
    return mappingDetail;
}
exports.makeMappingDetail = makeMappingDetail;
/*
assignment2 util
*/
/*
  Procedure: fromBinary
  Purpose: From binary to integer
*/
function fromBinary(bits) {
    return parseInt(bits, 2);
}
exports.fromBinary = fromBinary;
/*
  Procedure: memRead
  Purpose: read a 32-bit word from memory
*/
function memRead(address) {
    for (var i = 0; i < constants_1.MEM_NREGIONS; ++i) {
        if (address >= constants_1.memRegions[i].start &&
            address < constants_1.memRegions[i].start + constants_1.memRegions[i].size) {
            var offset = address - constants_1.memRegions[i].start;
            var result = (constants_1.memRegions[i].mem[offset + 3] << 24) |
                (constants_1.memRegions[i].mem[offset + 2] << 16) |
                (constants_1.memRegions[i].mem[offset + 1] << 8) |
                (constants_1.memRegions[i].mem[offset + 0] << 0);
            return result;
        }
    }
}
exports.memRead = memRead;
/*
  Procedure: memWrite
  Purpose: Write a 32-bit word to memory
*/
function memWrite(address, value) {
    constants_1.memRegions.forEach(function (memRegion) {
        if (address >= memRegion.start &&
            address < memRegion.start + memRegion.size) {
            var offset = address - memRegion.start;
            memRegion.mem[offset + 3] = (value >> 24) & 0xff;
            memRegion.mem[offset + 2] = (value >> 16) & 0xff;
            memRegion.mem[offset + 1] = (value >> 8) & 0xff;
            memRegion.mem[offset + 0] = (value >> 0) & 0xff;
            /* set_offBound */
            memRegion.dirty = true;
            if (memRegion.type === constants_1.MEM_GROW_UP) {
                memRegion.offBound =
                    offset + 4 > memRegion.offBound ? offset + 4 : memRegion.offBound;
            }
            else
                memRegion.offBound =
                    offset + 4 < memRegion.offBound ? offset + 4 : memRegion.offBound;
        }
    });
}
exports.memWrite = memWrite;
/*
  Procedure: memWriteHalf
  Purpose: Write a half of 32-bit word to memory
*/
function memWriteHalf(address, value) {
    constants_1.memRegions.forEach(function (memRegion) {
        if (address >= memRegion.start &&
            address < memRegion.start + memRegion.size) {
            var offset = address - memRegion.start;
            memRegion.mem[offset + 1] = (value >> 8) & 0xff;
            memRegion.mem[offset + 0] = (value >> 0) & 0xff;
            /* set_offBound */
            memRegion.dirty = true;
            if (memRegion.type === constants_1.MEM_GROW_UP)
                memRegion.offBound =
                    offset + 2 > memRegion.offBound ? offset + 2 : memRegion.offBound;
            else
                memRegion.offBound =
                    offset + 2 < memRegion.offBound ? offset + 2 : memRegion.offBound;
        }
    });
}
exports.memWriteHalf = memWriteHalf;
/*
  Procedure: initMemory
*/
function initMemory() {
    for (var i = 0; i < constants_1.MEM_NREGIONS; ++i) {
        constants_1.memRegions[i].mem = Array.from({ length: constants_1.memRegions[i].size }, function () { return 0; });
    }
}
exports.initMemory = initMemory;
/*
  Procedure: initInstInfo
*/
function initInstInfo(NUM_INST, INST_INFO) {
    for (var i = 0; i < NUM_INST; ++i) {
        INST_INFO[i].value = 0;
        INST_INFO[i].opcode = 0;
        INST_INFO[i].funcCode = 0;
        INST_INFO[i].rs = 0;
        INST_INFO[i].rt = 0;
        INST_INFO[i].rd = 0;
        INST_INFO[i].imm = 0;
        INST_INFO[i].shamt = 0;
        INST_INFO[i].target = 0;
    }
}
exports.initInstInfo = initInstInfo;
/*
  Procedure: get_inst_info
  Purpose: Read instruction information
*/
function getInstInfo(pc) {
    return constants_1.INST_INFO[(pc - constants_1.MEM_TEXT_START) >> 2];
}
exports.getInstInfo = getInstInfo;
/*
  Procedure: main process
*/
function mainProcess(INST_INFO, cycles, CYCLES) {
    return __awaiter(this, void 0, void 0, function () {
        var i, result;
        return __generator(this, function (_a) {
            i = cycles;
            result = '';
            return [2 /*return*/, new Promise(function (resolve, reject) {
                    try {
                        if (constants_1.DEBUG_SET) {
                            console.log("Simulating for ".concat(cycles, " cycles...!\n"));
                            console.log('MAIN PROCESS', CYCLES);
                            while (i > 0) {
                                cycle();
                                rdump();
                                if (constants_1.MEM_DUMP_SET)
                                    dumpMemory();
                                i -= 1;
                                if (constants_1.RUN_BIT === 0)
                                    break;
                            }
                        }
                        else {
                            running(i, CYCLES);
                            result += rdump();
                            if (constants_1.MEM_DUMP_SET) {
                                result += dumpMemory();
                            }
                            var EachCycle = rdump();
                            if (constants_1.MEM_DUMP_SET)
                                EachCycle += dumpMemory();
                            CYCLES.push(parseSimulatorOutput(EachCycle));
                        }
                        var returnObject = parseSimulatorOutput(result);
                        resolve(returnObject);
                    }
                    catch (error) {
                        reject(error);
                    }
                })];
        });
    });
}
exports.mainProcess = mainProcess;
/*
  Procedure: cycle
  Purpose: Execute a cycle
*/
function cycle() {
    (0, run_1.process_instruction)();
    (0, constants_1.instAddOne)();
}
exports.cycle = cycle;
function dumpMemory() {
    var dump_string = '';
    if (constants_1.memData.dirty) {
        var dstart = constants_1.memData.start;
        var dstop = constants_1.memData.start + constants_1.memData.offBound;
        dump_string += "Data section\n";
        dump_string += mdump(dstart, dstop);
        dump_string += '\n';
    }
    if (constants_1.memStack.dirty) {
        var dstart = constants_1.memStack.start + constants_1.memStack.offBound;
        var dstop = constants_1.memStack.start + constants_1.memStack.size - 4;
        dump_string += "Stack section\n";
        dump_string += mdump(dstart, dstop);
        dump_string += '\n';
    }
    return dump_string;
}
exports.dumpMemory = dumpMemory;
/*
  Procedure: mdump
  Purpose: Dump a word-aligned region of memory to the output file.
*/
function mdump(start, stop) {
    var mdump_string = '';
    for (var i = start; i < stop + 1; i += 4) {
        mdump_string += "0x".concat(toHexAndPad(i), ": 0x").concat(toHexAndPad(memRead(i)), "\n");
    }
    mdump_string += '\n';
    return mdump_string;
}
exports.mdump = mdump;
/*
  Procedure: rdump
  Purpose:  Dump current register and bus values to the output file.
*/
function rdump() {
    var rdump_string = '';
    rdump_string += 'Program Counter\n';
    rdump_string += "PC: 0x".concat(toHexAndPad(constants_1.currentState.PC), "\n");
    rdump_string += "Registers\n";
    for (var k = 0; k < constants_1.MIPS_REGS; ++k) {
        rdump_string += "R".concat(k, ": 0x").concat(toHexAndPad((constants_1.currentState.REGS[k] >>>= 0)), "\n");
    }
    rdump_string += '\n';
    return rdump_string;
}
exports.rdump = rdump;
/*
  Procedure: run n
  Purpose: Simulate MIPS for n cycles
*/
function running(num_cycles, CYCLES) {
    var running_string = '';
    if (constants_1.RUN_BIT === 0) {
        running_string = "Can't simulate, Simulator is halted\n";
    }
    running_string = "Simulating for ".concat(num_cycles, " cycles...!\n\n");
    for (var i = 0; i < num_cycles; ++i) {
        if (constants_1.RUN_BIT === 0) {
            running_string += "Simulator halted ".concat(i, "th cycle.\n\n");
            break;
        }
        var EachCycle = rdump();
        if (constants_1.MEM_DUMP_SET)
            EachCycle += dumpMemory();
        CYCLES.push(parseSimulatorOutput(EachCycle));
        cycle();
    }
    console.log(running_string);
}
exports.running = running;
